=== contrib/davelove/Makefile ===
SHELL=/bin/sh
all:
source:
install:
clean:
	rm -f *.dvi *.log *.aux
