=== contrib/leew/Makefile ===
SHELL=/bin/sh
all:
install:
source:
clean:
	rm -f nocond *.dvi *.log *.aux *.toc *.tex nocond.1
