=== contrib/ydirson/Makefile ===
LIB=/dev/null  # to be overridden

FILTERS=guesslang inheritlang enscript-html

# nothing to tangle or weave
all:
source:
clean:

install:
	cp -p $(FILTERS) $(LIB)
