=== debian/changelog ===
noweb (2.13-2) unstable; urgency=medium

  * [ce1923c] Bumped standard version - no changes needed
  * [783a3bc] Added FORCE_SOURCE_DATE=1 to build packge reproducible

 -- Mechtilde Stehmann <mechtilde@debian.org>  Sat, 19 Apr 2025 10:11:26 +0200

noweb (2.13-1) unstable; urgency=medium

  * [7d9beb5] Removed patches already integrated into upstream
  * [965811f] Removed already integrated patches from d/p/series
  * [8636376] New upstream version 2.13rc3
  * [22c1c0e] Rediff patches
  * [4c4ca28] Fixed remain string from merge confilct
  * [aeba973] New upstream version 2.13
  * [8bb93fd] Set encoding to UTF-8
  * [7b76913] Bumped compat version Bumped standard version - no changes needed
  * [666421a] Fixed versioning in d/watch
  * [821bf7f] Bumped year in d/copyright
  * [cd49bc4] Added d/u/metadata and d/salsa-ci.yml

 -- Mechtilde Stehmann <mechtilde@debian.org>  Fri, 04 Oct 2024 19:22:56 +0200
